/* BMP.C
 *	Programma di analisi dei files di tipo BMP di Windows
 */


#include	<STDIO.H>
#include	<STDLIB.H>
#include	<DIR.H>
#include	<FCNTL.H>
#include	<IO.H>
#include	<BIOS.H>
#include	<graphics.h>
#include	"BMP.H"

char bitmap [40000];	// Buffer per contenere la bitmap

typedef struct {
		char	iter;	// numero iterazioni per dato
		char	mult;	// Moltiplicatore del colore
		long	msk;	// maschera
	} bmap;


bmap maps [] = {
		{8,0xff,0x1},	// 1 bit (0)
		{8,0xff,0x1},	// 1 bit (1)
		{8,0xff,0x1},	// 1 bit (2)
		{8,0xff,0x1},	// 1 bit (3)
		{2,0xf,0xf},	// 4 bit (4)
		{2,0xf,0xf},	// 4 bit (5)
		{2,0xf,0xf},	// 4 bit (6)
		{2,0xf,0xf},	// 4 bit (7)
		{1,0x1,0xff},	// 8 bit (8)
	};

void main (int argc,char **argv)
{
struct ffblk ffblk;
int done;
int f;
struct BmpHead bmpi;
char filname [80];
char *endname;
/* request auto detection */
int gdriver = DETECT, gmode, errorcode;
int maxx,maxy,left,top,right,bottom;
int x,y;
int color;
unsigned curpx,curlong;

	if (argc != 2)
	{
		printf ("ERRORE: Uso :\nBMP <Prototipo file BMP>");
		exit (1);
	}


	strcpy (filname,argv [1]);
	for (done = strlen (filname);done && filname [done] != '\\' &&
		filname [done] != ':';done --);

	if (filname [done] == '\\' || filname [done] == ':')
		endname = filname + done + 1;
	else endname = filname + done;

	printf("Directory listing of %s\n",argv [1]);
	done = findfirst(argv [1],&ffblk,0);
	while (!done)
	{
		strcpy (endname,ffblk.ff_name);
		printf("  %s\n",filname);
		f = open (filname,O_RDONLY | O_BINARY);
		read (f,&bmpi,sizeof (struct BmpHead));

		printf ("Inizio         %c%c\n",bmpi.BM [0],bmpi.BM[1]);	// Inizia con BM (standard)
		printf ("Lungh. File    %ld\n",bmpi.BLen);	// Lunghezza complessiva del file
		printf ("Pad            %ld\n",bmpi.Pad);	// contiene 0
		printf ("Lung. Testata  %ld\n",bmpi.HLen);	// Lunghezza Testata (3E)
		printf ("Lung. Test. 1  %ld\n",bmpi.H1Len);	// 0E Lunghezza Prima Parte Testata
		printf ("Larghezza BMP  %ld\n",bmpi.Width);	// 12 Largheza BMP
		printf ("Altezza BMP    %ld\n",bmpi.Height);	// 16 Altezza Bmp
		printf ("Larg. Pixel    %d\n",bmpi.PWidth);	// 1A Larghezza Pixel
		printf ("Prof. Pixel    %d\n",bmpi.PDeep);// 1C Altezza Pixel

		lseek (f,bmpi.HLen,SEEK_SET);
		read (f,bitmap,(unsigned int) bmpi.BLen - bmpi.HLen);
		close (f);
		bioskey (0);

		/* initialize graphics mode */
		initgraph (&gdriver, &gmode, "");

		/* read result of initialization */
		errorcode = graphresult();

		if (errorcode != grOk)  /* an error occurred */
		{
			printf("Graphics error: %s\n", grapherrormsg(errorcode));
			printf("Press any key to halt:");
			bioskey (0);
		}
		else
		{
			maxx = getmaxx ();
			maxy = getmaxy ();
			left = (maxx - bmpi.Width) / 2;
			right = left + bmpi.Width;
			top = (maxy - bmpi.Height) / 2;
			bottom = top + bmpi.Height;
			rectangle (left - 1,top,right,bottom + 1);
			for (y = curlong = 0;y < bmpi.Height;y ++)
			{
				color = 12;
				curpx = maps [bmpi.PDeep].iter - 1;
				for (x = 0;x < bmpi.Width;x ++)
				{
					color = ((bitmap [curlong] >>
						(bmpi.PDeep * curpx)) &
							maps [bmpi.PDeep].msk) *
								maps [bmpi.PDeep].mult;
					if (curpx -- <= 0)
					{
						curpx = maps [bmpi.PDeep].iter - 1;
						curlong ++;
					}
					putpixel (left + x,bottom - y,color);
				}
				if (curpx < maps [bmpi.PDeep].iter - 1)
					curlong ++;
				curlong = (curlong + 3) & 0xfffc;
			}
			bioskey (0);
			closegraph ();
		}
		done = findnext(&ffblk);
	}

}
